package com.steerinfo.baseinfo.meterbasecarrierunitcar.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasecarrierunitcar.model.MeterBaseCarrierUnitCar;
import com.steerinfo.baseinfo.meterbasecarrierunitcar.service.IMeterBaseCarrierUnitCarService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

/**
 * MeterBaseCarrierUnitCar RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-16 09:53
 * 类描述
 * 修订历史：
 * 日期：2020-06-16
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCarrierUnitCar RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasecarrierunitcars")
@Api(value = "/${api.version}/meterbasecarrierunitcars", tags = "承运单位车辆维护 - MeterBaseCarrierUnitCarController")
public class MeterBaseCarrierUnitCarController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCarrierUnitCarService meterBaseCarrierUnitCarService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecarrierunitcar:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCarrierUnitCar> list = meterBaseCarrierUnitCarService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecarrierunitcar:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCarrierUnitCar> list = meterBaseCarrierUnitCarService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseCarrierUnitCar对象创建")
    @ApiImplicitParam(name = "meterBaseCarrierUnitCar", value = "详细实体meterBaseCarrierUnitCar", required = true, dataType = "MeterBaseCarrierUnitCar")
    //@RequiresPermissions("meterbasecarrierunitcar:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseCarrierUnitCar model) {
        try {
            String msg = meterBaseCarrierUnitCarService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecarrierunitcar:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseCarrierUnitCar meterBaseCarrierUnitCar = meterBaseCarrierUnitCarService.getById(id);
            return success(meterBaseCarrierUnitCar);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCarrierUnitCar信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCarrierUnitCar", value = "详细实体meterBaseCarrierUnitCar", required = true, dataType = "MeterBaseCarrierUnitCar")
    })
    //@RequiresPermissions("meterbasecarrierunitcar:update")
    @Transactional
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCarrierUnitCar model) {
        try {
            String msg = meterBaseCarrierUnitCarService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecarrierunitcar:delete")
    @PutMapping(value = "/")//String
    public RESTfulResult delete(@RequestBody List<MeterBaseCarrierUnitCar> models) {
        try {
            List<String> list = new ArrayList<String>();
            for (MeterBaseCarrierUnitCar model : models) {
                String id = model.getPkNo();
                list.add(id);
            }
            List<String> ids = ListUtils.convertList(list);
            meterBaseCarrierUnitCarService.delete(ids);
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "服役", notes = "根据传过来的MeterBaseCarrierUnitCar集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCarrierUnitCar", value = "详细实体MeterBaseCarrierUnitCar", required = true, dataType = "MeterBaseCarrierUnitCar")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody List<MeterBaseCarrierUnitCar> models) {
        try {
            String msg = meterBaseCarrierUnitCarService.Recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "停役", notes = "根据传过来的MeterBaseCarrierUnitCar集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCarrierUnitCar", value = "详细实体MeterBaseCarrierUnitCar", required = true, dataType = "MeterBaseCarrierUnitCar")
    })
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseCarrierUnitCar> models) {
        try {
            String msg = meterBaseCarrierUnitCarService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }
}
